# coding: utf-8

"""
    OGC API - Processes

    Example API Definition for OGC API - Processes  # noqa: E501

    The version of the OpenAPI document: 0.1
    Contact: info@ogc.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist, validator
from openapi_client.models.extent_spatial_grid_inner import ExtentSpatialGridInner

class ExtentSpatial(BaseModel):
    """
    The spatial extent of the data in the collection.
    """
    bbox: Optional[conlist(conlist(Union[StrictFloat, StrictInt]), min_items=1)] = Field(None, description="One or more bounding boxes that describe the spatial extent of the dataset. In the Core only a single bounding box is supported.  Extensions may support additional areas. The first bounding box describes the overall spatial extent of the data. All subsequent bounding boxes describe more precise bounding boxes, e.g., to identify clusters of data. Clients only interested in the overall spatial extent will only need to access the first item in each array.")
    crs: Optional[StrictStr] = Field('http://www.opengis.net/def/crs/OGC/1.3/CRS84', description="Coordinate reference system of the coordinates in the spatial extent (property `bbox`). The default reference system is WGS 84 longitude/latitude. In the Core the only other supported coordinate reference system is WGS 84 longitude/latitude/ellipsoidal height for coordinates with height. Extensions may support additional coordinate reference systems and add additional enum values.")
    grid: Optional[conlist(ExtentSpatialGridInner, max_items=3, min_items=2)] = Field(None, description="Provides information about the limited availability of data within the collection organized as a grid (regular or irregular) along each spatial dimension.")
    __properties = ["bbox", "crs", "grid"]

    @validator('crs')
    def crs_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('http://www.opengis.net/def/crs/OGC/1.3/CRS84', 'http://www.opengis.net/def/crs/OGC/0/CRS84h'):
            raise ValueError("must be one of enum values ('http://www.opengis.net/def/crs/OGC/1.3/CRS84', 'http://www.opengis.net/def/crs/OGC/0/CRS84h')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ExtentSpatial:
        """Create an instance of ExtentSpatial from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in grid (list)
        _items = []
        if self.grid:
            for _item in self.grid:
                if _item:
                    _items.append(_item.to_dict())
            _dict['grid'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ExtentSpatial:
        """Create an instance of ExtentSpatial from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ExtentSpatial.parse_obj(obj)

        _obj = ExtentSpatial.parse_obj({
            "bbox": obj.get("bbox"),
            "crs": obj.get("crs") if obj.get("crs") is not None else 'http://www.opengis.net/def/crs/OGC/1.3/CRS84',
            "grid": [ExtentSpatialGridInner.from_dict(_item) for _item in obj.get("grid")] if obj.get("grid") is not None else None
        })
        return _obj

