# coding: utf-8

"""
    OGC API - Processes

    Example API Definition for OGC API - Processes  # noqa: E501

    The version of the OpenAPI document: 0.1
    Contact: info@ogc.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from openapi_client.models.format_schema import FormatSchema
from openapi_client.models.input_value import InputValue

class QualifiedInputValue(BaseModel):
    """
    QualifiedInputValue
    """
    media_type: Optional[StrictStr] = Field(None, alias="mediaType")
    encoding: Optional[StrictStr] = None
    var_schema: Optional[FormatSchema] = Field(None, alias="schema")
    value: InputValue = Field(...)
    __properties = ["mediaType", "encoding", "schema", "value"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> QualifiedInputValue:
        """Create an instance of QualifiedInputValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of var_schema
        if self.var_schema:
            _dict['schema'] = self.var_schema.to_dict()
        # override the default output from pydantic by calling `to_dict()` of value
        if self.value:
            _dict['value'] = self.value.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> QualifiedInputValue:
        """Create an instance of QualifiedInputValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return QualifiedInputValue.parse_obj(obj)

        _obj = QualifiedInputValue.parse_obj({
            "media_type": obj.get("mediaType"),
            "encoding": obj.get("encoding"),
            "var_schema": FormatSchema.from_dict(obj.get("schema")) if obj.get("schema") is not None else None,
            "value": InputValue.from_dict(obj.get("value")) if obj.get("value") is not None else None
        })
        return _obj

